package game;

import gui.TestThreadGui;
import game.Punto;
import game.Retta;
import wiiusej.WiiUseApiManager;
import wiiusej.Wiimote;
import wiiusej.values.IRSource;
import wiiusej.values.RawAcceleration;
import wiiusej.wiiusejevents.physicalevents.ExpansionEvent;
import wiiusej.wiiusejevents.physicalevents.IREvent;
import wiiusej.wiiusejevents.physicalevents.MotionSensingEvent;
import wiiusej.wiiusejevents.physicalevents.WiimoteButtonsEvent;
import wiiusej.wiiusejevents.utils.WiimoteListener;
import wiiusej.wiiusejevents.wiiuseapievents.ClassicControllerInsertedEvent;
import wiiusej.wiiusejevents.wiiuseapievents.ClassicControllerRemovedEvent;
import wiiusej.wiiusejevents.wiiuseapievents.DisconnectionEvent;
import wiiusej.wiiusejevents.wiiuseapievents.GuitarHeroInsertedEvent;
import wiiusej.wiiusejevents.wiiuseapievents.GuitarHeroRemovedEvent;
import wiiusej.wiiusejevents.wiiuseapievents.NunchukInsertedEvent;
import wiiusej.wiiusejevents.wiiuseapievents.NunchukRemovedEvent;
import wiiusej.wiiusejevents.wiiuseapievents.StatusEvent;

public class GestioneEventi implements WiimoteListener {

    
    private TestThreadGui finestra = null;

    //private Retta spada = new Retta();
    private IRSource[] listaPunti;
    private boolean elaborazione = false;
    private static Punto CENTRO = new Punto(512, 384);
    private static int MAX_NB_POINTS = 4;
    private String level;
    int distMax=150;
    Wiimote wiimote;

    public GestioneEventi() {
        finestra = new TestThreadGui();
        finestra.setVisible(true);

    }

    public GestioneEventi(Wiimote w) {
    	this.wiimote = w;
    	finestra = new TestThreadGui(w);
        finestra.setVisible(true);

    }

    public GestioneEventi(Wiimote w, int level) {
    	this.wiimote = w;
    	finestra = new TestThreadGui(w,level);
        finestra.setVisible(true);

    }

    @Override
    public void onButtonsEvent(WiimoteButtonsEvent arg0) {


        if (arg0.getButtonsJustPressed() != 0) {
            System.out.println("bottone premuto: " + arg0.getButtonsJustPressed());
        }
    // TODO Auto-generated method stub

    }

    @Override
    public void onClassicControllerInsertedEvent(
            ClassicControllerInsertedEvent arg0) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onClassicControllerRemovedEvent(
            ClassicControllerRemovedEvent arg0) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onDisconnectionEvent(DisconnectionEvent arg0) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onExpansionEvent(ExpansionEvent arg0) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onGuitarHeroInsertedEvent(GuitarHeroInsertedEvent arg0) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onGuitarHeroRemovedEvent(GuitarHeroRemovedEvent arg0) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onIrEvent(IREvent arg0) {
        // TODO Auto-generated method stub
    	
        

        //System.out.println(arg0);
        System.out.println("spento");
        listaPunti = arg0.getIRPoints();
        wiimote.deactivateIRTRacking();
        
        //System.out.println(listaPunti.length);



        if (listaPunti.length >= 2) {
        	
        	Punto punto1=new Punto(); 
            Punto punto2=new Punto();
            Retta spada = new Retta();

            //System.out.println("inizio");

            //elaborazione = true;

            punto1.setX(listaPunti[0].getRx());
            punto1.setY(listaPunti[0].getRy());

            punto2.setX(listaPunti[1].getRx());
            punto2.setY(listaPunti[1].getRy());

            //retta tra i due punti che rappresenta la spada
            spada.setValori(punto1, punto2);



            Double distanza = CENTRO.distanzaR(spada);

            //System.out.println("la distanza della spada dal centro �: "+distanza.toString());

            if (distanza < distMax) {
                //System.out.println("Colpo parato!");

                synchronized (finestra.laser) {
                    if (finestra.laser.spadaAttiva) {
                        finestra.laser.parato = true;
                        finestra.laser.notify();
                    }
                }
            } else {

                //System.out.println("Non hai parato il colpo!");
                }


            
        //elaborazione = false;
        }

        System.out.println("acceso");
        wiimote.activateIRTRacking();
    }

    @Override
    public void onMotionSensingEvent(MotionSensingEvent arg0) {
        // TODO Auto-generated method stub

        RawAcceleration acc = arg0.getRawAcceleration();
        int x = acc.getX();
        int y = acc.getY();
    }

    @Override
    public void onNunchukInsertedEvent(NunchukInsertedEvent arg0) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onNunchukRemovedEvent(NunchukRemovedEvent arg0) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onStatusEvent(StatusEvent arg0) {
        // TODO Auto-generated method stub
    }
    
//    public static void main(String[] args) {
//    	Wiimote[] wiimotes= WiiUseApiManager.getWiimotes(2, true);
//		Wiimote wiimote = wiimotes[0];
//		int id=wiimote.getId();
//
//
//		System.out.println("Id del wiimote connesso: "+id);
//
//		wiimote.activateIRTRacking();
//		//wiimote.activateMotionSensing();
//		wiimote.setIrSensitivity(5);
//		wiimote.setLeds(false, true, false, true);
//
//		//apre la finestra con le coordinate dei punti
//		//wiimote.addWiiMoteEventListeners(finestra);
//		TestThreadGui a = new TestThreadGui(wiimote);
//		wiimote.addWiiMoteEventListeners(a);
//		a.setVisible(true);
//		
//	}
}
