package game;

//derived from SUN's examples in the javax.comm package
import java.io.*;
import java.util.*; //import javax.comm.*; // for SUN's serial/parallel port libraries


import gui.TestThreadGui;

import game.Punto;
import gnu.io.*; // for rxtxSerial library

public class Laser extends Thread {

    // variabili per la porta seriale
    String wantedPortName = "/dev/ttyUSB0";
    SerialPort port = null;
    Enumeration portIdentifiers = CommPortIdentifier.getPortIdentifiers();
    PrintStream os;
    CommPortIdentifier portId = null; // will be set if port found
    // variabili del laser
    boolean pleaseWait = false;
    public boolean parato = false;
    boolean spadaAttiva = false;
    public boolean allDone = false;
    int delay = 1500;
    int pausa = 1500;
    int parati;
    int subiti;
    TestThreadGui gui = null;
    private ArrayList<String> posizioni = new ArrayList<String>();

    public void trovaPorta() {
        while (portIdentifiers.hasMoreElements()) {
            CommPortIdentifier pid = (CommPortIdentifier) portIdentifiers.nextElement();
            if (pid.getPortType() == CommPortIdentifier.PORT_SERIAL && pid.getName().equals(wantedPortName)) {
                portId = pid;
                break;
            }
        }
        if (portId == null) {
            System.err.println("Could not find serial port " + wantedPortName);
            System.exit(1);
        } else {
            System.out.println("Porta trovata! ID: " + portId);
        }
        //
        // Use port identifier for acquiring the port
        //

        try {
            port = (SerialPort) portId.open("name", // Name of the application
                    // asking for the port
                    2000 // Wait max. 10 sec. to acquire port
                    );
        } catch (PortInUseException e) {
            System.err.println("Port already in use: " + e);
            System.exit(1);
        }
        //
        // Now we are granted exclusive access to the particular serial
        // port. We can configure it and obtain input and output streams.
        //

        // initialize the port

        try {
            port.setSerialPortParams(115200, SerialPort.DATABITS_8,
                    SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
        } catch (UnsupportedCommOperationException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        try {
            os = new PrintStream(port.getOutputStream(), true);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }

    public void inviaCar(String s) {
        // Write to the output
        os.print(s);
        // os.print("\r\n"); // Append a carriage return with a line feed
    }

    public void initPosition() {
//		posizioni.add("S##\r");
//		posizioni.add("S-\n\r");
//		posizioni.add("S 8\r");
//		posizioni.add("Saa\r");
//		posizioni.add("S92\r");
//		posizioni.add("SA0\r");
//		posizioni.add("SPn\r");
        posizioni.add("S r\r");
        posizioni.add("S R\r");
        posizioni.add("S 7\r");


    }

    public String getPosizioneRandom() {

        Random ran = new Random();
        String p = posizioni.get(ran.nextInt(posizioni.size()));

        return p;
    }

    public void setGui(TestThreadGui gui) {
        this.gui = gui;
    }

    public void run() {
        // first thing in the thread, we initialize the write operation
        trovaPorta();
        initPosition();

        String pos;
		String pos2;
		
		pos=getPosizioneRandom();
		

		int i = 0;
		System.out.println("laser avviato!");

		// Check if should wait
		synchronized (this) {
			while (!pleaseWait) {
				try {
					parato = false;
					
					pos2=getPosizioneRandom();
					
					while(pos==pos2) {
						pos2=getPosizioneRandom();
					}
					pos=pos2;
					System.out.println("posiziono il laser in "+ pos2);
					inviaCar(pos2);
                    System.out.println("sparo il colpo numero " + (i + 1));
                    try {

                        Runtime.getRuntime().exec("aplay sound/laser-1.wav");

                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    spadaAttiva = true;
                    wait(delay);
                    spadaAttiva = false;

                    // controllo se � stato parato il colpo
                    if (parato) {
                        System.out.println("colpo parato!");
                        Runtime.getRuntime().exec("aplay sound/colpo-spada.wav");
                        parati++;

                        //aggiornare nella gui i colpi parati
                        gui.setParati(parati);


                    } else {
                        System.out.println("colpo non parato");
                        Runtime.getRuntime().exec("aplay sound/Bleep.wav");
                        subiti++;

                        //aggiornare nella gui i colpi subiti
                        gui.setSubiti(subiti);

                    }
                    i++;
                    
                    if (allDone) {
                    	System.out.println("termino il laser");
                        return;
                    }

                    System.out.println("preparazione nuovo colpo...");
                    wait(pausa);

                } catch (Exception e) {
                }
            }
        }

    }

    public static void main(String[] args) {
        Laser l = new Laser();
        l.start();
    }

    public void setLevel(int level) {
        switch (level) {
            case (0): this.delay=2000;
                      this.pausa=1500;

            case (1): this.delay=1500;
                      this.pausa=1000;

            case (2): this.delay=1000;
                      this.pausa=1000;

        }

    }
}
