package game;

public class Punto {
	protected double x, y;

	/** Costruttore: punto origine del sistema di assi */
	public Punto() {
		x = 0;
		y = 0;
	}

	/** Overloading del Costruttore */
	public Punto(double a, double b) {
		x = a;
		y = b;
	}

    public void setX(double x) {
        this.x=x;
    }

    public void setY(double y) {
        this.y=y;
    }

	/** Verifica se due punti sono uguali */
	public boolean equals(Punto p) {
		return (x == p.x && y == p.y);
	}

	/** Overloading del metodo toString */
	public String toString() {
		return "(" + x + ", " + y + ")";
	}

	/** Stampa le coordinate del punto */
	public void stampaPunto() {
		System.out.println("Coordinate del punto: " + this.toString());
	}

	/** Distanza tra due punti */
	public double distanza(Punto p) {
		return Math.sqrt((p.x - this.x) * (p.x - this.x) + (p.y - this.y)
				* (p.y - this.y));
	}
	
	/** Distanza da una retta */
	
	public double distanzaR(Retta r) {
		//retta passante per il punto e perpendicolare alla retta r
		Retta s = new Retta(this,1/r.m );
		
		//System.out.println("retta per il centro: m= "+r.m+" , p= "+r.p0.toString());
		
		//punto di intersezione tra r e s
		Punto p=r.intersezione(s);
		//System.out.println("punto di intersezione: "+p.toString());
		
		//calcolo la distanza tra il punto trovato e il punto di partenza
		Double distanza=p.distanza(this);
		
		return distanza;
		
	}
} // fine classe Punto
